/*
*	New C++ File starts here.
*	This file should be named lqrn.cpp
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "lqrn.hh"

// Forward Function Prototypes

/*
*	NML/CMS Format function : lqrFormat
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Sep 13 22:45:00 EDT 1999
*/
int lqrFormat(NMLTYPE type, void *buffer, CMS *cms)
{
	switch(type)
	{
	case LQR_HALT_TYPE:
		((LQR_HALT *) buffer)->update(cms);
		break;
	case LQR_INIT_TYPE:
		((LQR_INIT *) buffer)->update(cms);
		break;
	case LQR_RUN_TYPE:
		((LQR_RUN *) buffer)->update(cms);
		break;
	case LQR_SET_GAINS_TYPE:
		((LQR_SET_GAINS *) buffer)->update(cms);
		break;
	case LQR_STATUS_TYPE:
		((LQR_STATUS *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}


// NML Symbol Lookup Function
const char *lqr_symbol_lookup(int type)
{
	switch(type)
	{
	case LQR_HALT_TYPE:
		return "LQR_HALT";
	case LQR_INIT_TYPE:
		return "LQR_INIT";
	case LQR_RUN_TYPE:
		return "LQR_RUN";
	case LQR_SET_GAINS_TYPE:
		return "LQR_SET_GAINS";
	case LQR_STATUS_TYPE:
		return "LQR_STATUS";
	default:
		return"UNKNOWN";
		break;
	}
	return(NULL);
}

/*
*	NML/CMS Update function for LQR_SET_GAINS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Sep 13 22:45:00 EDT 1999
*/
void LQR_SET_GAINS::update(CMS *cms)
{
	cms->update(lqr_gains,4);

}


/*
*	NML/CMS Update function for LQR_HALT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Sep 13 22:45:00 EDT 1999
*/
void LQR_HALT::update(CMS *cms)
{

}


/*
*	NML/CMS Update function for LQR_STATUS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Sep 13 22:45:00 EDT 1999
*/
void LQR_STATUS::update(CMS *cms)
{
	cms->update(plant_state,4);
	cms->update(ctrl_output);

}


/*
*	NML/CMS Update function for LQR_RUN
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Sep 13 22:45:00 EDT 1999
*/
void LQR_RUN::update(CMS *cms)
{
	cms->update(reference_input);

}


/*
*	NML/CMS Update function for LQR_INIT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Sep 13 22:45:00 EDT 1999
*/
void LQR_INIT::update(CMS *cms)
{

}

/*
*	Constructor for LQR_SET_GAINS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Sep 13 22:45:00 EDT 1999
*/
LQR_SET_GAINS::LQR_SET_GAINS()
	: RCS_CMD_MSG(LQR_SET_GAINS_TYPE,sizeof(LQR_SET_GAINS))
{
	/*
	* The array lqr_gains should be initialized here.
	*/


}

/*
*	Constructor for LQR_HALT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Sep 13 22:45:00 EDT 1999
*/
LQR_HALT::LQR_HALT()
	: RCS_CMD_MSG(LQR_HALT_TYPE,sizeof(LQR_HALT))
{

}

/*
*	Constructor for LQR_STATUS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Sep 13 22:45:00 EDT 1999
*/
LQR_STATUS::LQR_STATUS()
	: RCS_STAT_MSG(LQR_STATUS_TYPE,sizeof(LQR_STATUS))
{
	/*
	* The array plant_state should be initialized here.
	*/

	ctrl_output = (double) 0;

}

/*
*	Constructor for LQR_RUN
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Sep 13 22:45:00 EDT 1999
*/
LQR_RUN::LQR_RUN()
	: RCS_CMD_MSG(LQR_RUN_TYPE,sizeof(LQR_RUN))
{
	reference_input = (double) 0;

}

/*
*	Constructor for LQR_INIT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Sep 13 22:45:00 EDT 1999
*/
LQR_INIT::LQR_INIT()
	: RCS_CMD_MSG(LQR_INIT_TYPE,sizeof(LQR_INIT))
{

}

